﻿/****************************************************************************/
//Main APPX Functions : appx-client-main.js
//01/28/2014
//Chris Smith
/****************************************************************************/


//$("#appx_login_modul button").click(function () { start_session(); });
$("#btn_appx_login").click(function () { start_session(); });
$("#btn_appx_reconnect").click(function () { reconnect_session(); });
//if ($.cookie("appxpid") == null || $.cookie("appxpid") == 0) {
$("#appx_login_modul input").keyup(function (event) {
    if (fixKeyEvent(event) && (event.which == 10 || event.which == 13)) start_session();
});
$("#appx_login_modul").show();
$("#appx_server").focus();

//$("#appx_reconnect_modul button").click(function () { reconnect_session(); });
//if ($.cookie("appxpid") != 0 && $.cookie("appxpid") != null) {
//    $("#appx_reconnect_modul").show();
$("#appx_reconnect_modul").hide();
//}

$(document).ready(function () {
    if (appxNoReconPopup == "true")
        return;

    if (localStorage["appx_prev_pids"]) {
        var prev_pids = JSON.parse(localStorage["appx_prev_pids"]);
        if (prev_pids.length > 0) {
            $("#btn_appx_reconnect").css({ "background": "lime" });
            var a = $('<div class="ui-widget"  style="margin-left: 100px; width:374px;"><div class="ui-state-highlight ui-corner-all" style="margin: 0px; padding: 0 .7em;"><p><span class="ui-icon ui-icon-info" style="float: left; margin-right: .3em;"></span><strong>Hi!</strong> We detected a previous User Session.  If you would like to reconnect, enter your password and click the \"Reconnect\" button.</p></div></div>')
            .appendTo("#appx_main_container");
            //$(a).append("<strong>We detected a previous User Session.  Would you like to reconnect?  If so, enter you password.</strong><br><input type='password' id='repass'>")
            //.appendTo("body");

            //	    $(a).dialog({
            //		    resizable: false,
            //			height: 200,
            //			modal: true,
            //			buttons: {
            //			"Yes": function () {
            //			    //alert($("#repass").val());
            //			    if ($("#repass").val().trim() != "") {
            //				$("#appx_password").val($("#repass").val());
            //				reconnect_session();
            //				$(this).dialog("close");
            //			    } else {
            //				alert("Please enter you password!")
            //                    }
            //			},
            //			    "No": function () {
            //				$(this).dialog("close");
            //			    }
            //		    }
            //		});
            //	    $(a).dialog().show();
            var last;
            var prev_pids = JSON.parse(localStorage["appx_prev_pids"]);
            for (var cnt = 0; cnt < prev_pids.length; cnt++) {
                $("#prev_pids").prepend("<option>" + prev_pids[cnt] + "</option>")
                last = prev_pids[cnt];
            }
            $("#prev_pids").change(function () {
                $("#appx_reconnect").val($(this).val());
            });
            $("#appx_reconnect").val(last.trim());
            $("#prev_pids").show().after(" Previous Sessions<br/>");
        }
    }
});

//Client To Server Functions - each of these will likely have a handler name myfunctionhandler();

// Appx Main Functions - These may be Injected after the get_appx_init call from the main APPX session object
// or built into the client

function appxobjectcreatehandler(msg) {
    console.log("appxobjectcreatehandler: " + JSON.stringify(msg.data));
    appxSetLocked(true);
    //MCreateReturn(int handle, int error)
    appx_session.objItems = [];
    appx_session.ws.send(JSON.stringify({
        cmd: 'appxmessage',
        args: [0, 0, 0, 0, 0, 0, 0, 0],//0, 0, 0, 1
        handler: 'appxobjectcreatehandler',
        data: null
    }));
}
function appxobjectinvokehandler(msg) {
try {
    console.log("appxobjectinvokehandler: " + JSON.stringify(msg.data));

    /*if (msg.data.proto.indexOf("void") == -1) {
        //MInvokeReturn(int error)
        //retblock + argblock
    }*/

    //AppxTokenScan
    if (msg.data.proto.indexOf("addListItem") != -1) {
        appx_session.objItems.push(msg.data.argBlocks[0].dataObject);
    } else if (msg.data.proto.indexOf("showTheList") != -1) {
        var cur = appxGetCursorPos();
        var $tag = $("#appxitem_" + cur.col + "_" + cur.row);
        if ($tag.length) {
            //FIXME: selectbox not working right on android chrome
            var $sel = $('<select>');
            var len = appx_session.objItems.length;
            var val = $tag.val();
            for (var i = 0; i < len; i++) {
                var $opt = $('<option>')
                    .attr('value', i + 1)
                    .html(appx_session.objItems[i]).appendTo($sel)
                ;
                if (appx_session.objItems[i] == val)
                    $opt.attr('selected', 'selected');
            }
            //need some extra z-index to be on top of following scrolling records
            var zin = 99999;//$tag.css('z-index')
            $sel.appendTo($tag.parent())
                .attr('size', (len > 10 ? 10 : len))
                .blur(appxFireObjectEvent)
                //.change(appxFireObjectEvent)//allow keyboard use
                .click(appxFireObjectEvent)
                .css({ 'position': 'absolute', 'z-index': zin })
                .focus()
                //.keydown//see sendkey()
                .offset($tag.offset())
                .css({"min-width": $tag.width()})
                //.width($tag.width())
            ;
            $tag.hide();
            appx_session.objFocus = $sel;
            //fyi: show timeout doesn't seem to be set when user object has focus
            //TODO: choosing 'select path' and then the same key could have issues?
            //appxSetLocked(false);//needed?
        } else {
            //this happens for example after choosing select path on the same key
            appx_session.objFocus = $("<select>").val('0');//fake it
            appxFireObjectEvent();
        }
    }
} catch (ex) { alert("appxobjectinvokehandler: " + ex); }
}
function appxFireObjectEvent() {
    console.log("appxFireObjectEvent " + appx_session.objFocus);
    if (appx_session.objFocus) {
        //MObjectEvent(int handle, int retCode)
        var val = appx_session.objFocus.val();
        val = (val > 255 ? 255 : val);
        appx_session.objFocus = null;
        appx_session.ws.send(JSON.stringify({
            cmd: 'appxmessage',
            args: [0, 0, 0, 0, 0, 0, 0, val],
            handler: 'appxobjectinvokehandler',
            data: null
        }));
    }
}
function appxobjectdestroyhandler(msg) {
    appxSetLocked(false);
    //appxSetScanning(false);
    console.log("appxobjectdestroyhandler");
    appx_session.objFocus = null;
}
