

//var a = $(items);
var menugroups = [];
var menulabels = [];
var menuitems = [];
var menu = {};
var menu2 = {};

function MenuTree() {
    this.fileMenu = null;
    this.userMenu = [];
    this.optnMenu = null;
    this.helpMenu = null;
}

function MenuNode(label,widget) {
    this.label = label;
    this.widget = widget;
    this.children = [];
}

function MenuItem(label,widget) {
    this.label = label;
    this.widget = widget;
}

function mGroup( menuGroup, label, widget ) {
    this.menuGroup = menuGroup;
    this.label = label;
    this.widget = widget;
    this.children = [];
}

function mChild(menuLabel,label,widget) {
    this.menuLabel = menuLabel;
    this.label = label;
    this.widget = widget;
}

function initializeMenu() {

    //$("#main_menu").remove();
    //$("#toolbar").remove();
    $("#appx-softkeys-container .toolbaritem").remove();
    $("#appx-defaulttools-container .toolbaritem").remove();

    appx_session.currentmenu = {};

    appx_session.currentmenu.groupsprocessed = [];
    appx_session.currentmenu.groups = {};

    //var menuhtml = $("<div>").css({ "width": "100%", "height": "350px", "border": "3px solid #ccc", "background": "#eeffee", "float": "left", "overflow": "scroll" }).html("Menus <br/> <br/>");
    //var boxarray = [];
    //begin while menus
    //var menuhtml = $('<div id="main_menu" style="position:absolute; top:0px; left:' + $("#appx_main_container").css("left") + ';">');
    //var toolbar = $('<div id="too_bar" style="position:absolute; top:30px; left:' + $("#appx_main_container").css("left") + ';">');
    //        var menuhtml = $('<nav id="main_menu">');
    //var toolbar = $('<div id="toolbar">');

    //        $(menuhtml).css({ "font-size": "13px", "font-family": "arial", "height": "25px", "background": "#efefef", "width": $("#appx_main_container").width(), "top": "0px", "left": ($(document).width() - $("#appx_main_container").width()) / 2, "border-left": "0px solid #D4D0C8", "border-right": "0px solid #D4D0C8" });
    //$(toolbar).css({ "position": "absolute", "height": "45px", "width": $("#appx_main_container").width(), "top": "30px", "left": ($(document).width() - $("#appx_main_container").width()) / 2, "border-left": "0px solid #D4D0C8", "border-right": "0px solid #D4D0C8" });
    //$(toolbar).addClass("appx-toobar");  //.css({ "position": "absolute", "height": "45px", "width": $("#appx_main_container").width(), "top": "30px", "left": ($(document).width() - $("#appx_main_container").width()) / 2, "border-left": "0px solid #D4D0C8", "border-right": "0px solid #D4D0C8" });

    //        var group;
    //        var item;
    //        var currgroup = "top_menu";
    //        var prevgroup = "top_menu";
    //        var gi = 0;

    //        group = $('<ul class="menu_top" id="top_menu">');
    //        item = $('<li class="menu_item">');
    //        //<h3>Main Menu</h3>
    //        //$(menuhtml).append("<h2>Main Menu</h2>");
    //        $(menuhtml).append(group);
    //$(toolbar).append("<h2>Tool Bar</h2>");
    //$("body").append(menuhtml);
    //$("body").append(toolbar);
    //$("#appx-toolbar").append(toolbar);

    appx_session.currentmenu.groupsprocessed.push("top_menu");

    //$(group).append("<li><a>File</a><ul><li><a>Print Setup</a></li><li><a>Print Setup</a></li><li><a>Print Setup</a></li><li><a>Print Setup</a></li></ul></li>");

    appx_session.menucache = {};
    appx_session.menucache.currentmenuitems = appx_session.currentmenuitems;
    appx_session.menucache.currentmenu = appx_session.currentmenu;


    appx_session.currentmenuitems = {};
    appx_session.currentmenuitems.all = [];
    appx_session.currentmenuitems.toolbar = [[], [], []];
    appx_session.currentmenuitems.dropdown = [[], [], []];
    appx_session.currentmenuitems.popup = [[], [], []];
    appx_session.currentmenu.block = {};
    appx_session.currentmenu.header = [];
}


//MENU Message Handler
function appxmenuhandler(x) {
    //alert("got a resource...");
    //inject_image2(x.data.data);
    appx_session.currentmenu.block = x;
    appx_session.currentmenu.header.push(new Widget(null, null, appx_session.currentmenu.block.data.headerdata));

    //In LOCALOS for testing
    appxmenushandler(x);
}

//Menus Message Handler
function appxmenushandler(x) {

    var menu = x.data;
    var menuType = menu.type[0];

    //split menu.headerdata into vars
    var mw = new Widget(null, null, null);
    mw.widgetData = x.data.headerdata;
    var menuheader = mw.parseDataIntoPairs();
    $.each(menuheader, function (k, v) { menuheader[v.key] = v.value; });

    //if use=t, reuse last menu
    if (menuheader.USE) {

        switch (menuheader.USE.trim()) {
            case "T":
                appx_session.currentmenuitems.toolbar[menuType] = appx_session.menucache.currentmenuitems.toolbar[menuType];
                appx_session.currentmenuitems.dropdown[menuType] = appx_session.menucache.currentmenuitems.dropdown[menuType];
                appx_session.currentmenuitems.popup[menuType] = appx_session.menucache.currentmenuitems.popup[menuType];
                break;
            default:
        }

    } else {

        if (menu.items.length > 0) {

            var i = 1;

            while (menu.items.length > 0) {

                var mx = menu.items.shift();

                mx.widget = new Widget(null, null, mx.data);

                appx_session.currentmenuitems.all.push(mx.widget);

                if (mx.widget.wUsageToolbar == true) {

                    appx_session.currentmenuitems.toolbar[menuType].push(mx.widget);

                }

                if (mx.widget.wUsagePopup == true) {

                    appx_session.currentmenuitems.popup[menuType].push(mx.widget);

                }

                if (mx.widget.wUsageMenu == true) {

                    appx_session.currentmenuitems.dropdown[menuType].push(mx.widget);

                }
            }

        }

    }

}


//for debug purpose
function buildMenuList(a) {
	for (var i = 0; i < a.length; i++) {
	    var b = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wLabel);
	    var c = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wGroupName);
	    var d = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wUsagePopup);
	    var e = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wUsageMenu);
	    var f = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wCommand);
	    //var g = $("<div style='float:left; border: 3px solid #eee; width: 18%; height: 25px; padding: 5px;'>").html(a[i].wLayer);

	    $("#menu").append(b);
	    $("#menu").append(c);
	    $("#menu").append(d);
	    $("#menu").append(e);
	    $("#menu").append(f);
	    //$("#menu").append(g);
	    $("#menu").append("<br>\n");

	}
}

//    function initMenu(m) {
//    
//    }
function fixMenuLabelsAndGroups(m,defaultGroup,menuTree) {

	    // This function will recode the menu list to ensure that 
	    // duplicate menu group names are unique and that the group
	    // children are attached to the correct parent group.  We 
	    // do this by adding a prefix of OptNo + : as a prefix to 
	    // the group name.  We determine which group a child belongs
	    // to by attaching children to the parent group that has the
	    // highest OptNo that is less than our child OptNo.  If there
	    // isn't one less than our child OptNo then we attach it to
	    // the first menu with the right name and the lowest OptNo
	    //
	    // For example, this raw menu structure...
	    //
	    // OptNo Label                Group
	    // ----- -------------------- --------------------
	    //   10  Inputs               Code Files
	    //   20  Countries            Inputs
	    //   30  Timezones            Inputs
	    //   40  Countries            Reports
	    //   50  Timezones            Reports
	    //   60  Reports              Code Files
	    //   70  Inputs               Master Files
	    //   80  Reports              Master Files
	    //   90  Customers            Inputs
	    //  100  Brokers              Inputs
	    //  110  Customers            Reports
	    //  120  Brokers              Reports
	    //
	    // Gets some group name changes to Become this...
	    //
	    // OptNo Label                Group
	    // ----- -------------------- --------------------
	    //   10  10:Inputs            Code Files
	    //   20  Countries            10:Inputs
	    //   30  Timezones            10:Inputs
	    //   40  Countries            60:Reports
	    //   50  Timezones            60:Reports
	    //   60  60:Reports           Code Files
	    //   70  70:Inputs            Master Files
	    //   80  80:Reports           Master Files
	    //   90  Customers            70:Inputs
	    //  100  Brokers              70:Inputs
	    //  110  Customers            80:Reports
	    //  120  Brokers              80:Reports
	    //
	    // Which gets processed from top to bottom to create a one level deep nested array like this...
	    //
	    // menu[Files       ] = []
            // menu[Code Files  ] = [ 10:Inputs,      60:Reports    ]
            // menu[10:Inputs   ] = [ Countries(20),  Timezones(30) ]
	    // menu[60:Reports  ] = [ Countries(40),  Timezones(50) ]
	    // menu[Master Files] = [ 70:Inputs,      80:Reports    ]
	    // menu[70:Inputs   ] = [ Customers(90),  Brokers(100)  ]
	    // menu[80:Reports  ] = [ Customers(110). Brokers(120)  ]
	    // menu[Options     ] = []
	    // menu[Help        ] = []
	    //
	    // Which gets processed recursively by index number to become this...
	    //
	    // Files
	    // Code Files
	    //   10:Inputs
	    //     Countries(20)
	    //     Timezones(30)
	    //   60:Reports
	    //     Countries(40)
	    //     Timezones(50)
	    // Master Files
	    //   70:Inputs
	    //     Customers(90)
	    //     Brokers(100)
	    //   80:Reports
	    //     Customers(110)
	    //     Brokers(120)
	    // Options
	    // Help
	    //
	    // Which will end up getting rendered like this...
	    //
	    //  [Files]   [Code Files]   [Master Files]   [Options]   [Help]
	    //              10:Inputs      70:Inputs
	    //                Countries      Customers
	    //                Timezones      Brokers
	    //              60:Reports     80:Reports
	    //                Countries      Customers
	    //                Timezones      Brokers

	    //*********************************
	    // 1 - Create a list of menu groups
	    //*********************************

	    var groupCount = 0;
	    var workGroups = [];

	    // Add known menu groups
	    //workGroups["process"] = [];
	    //workGroups["application"] = [];
	    //workGroups["system"] = [];
	    workGroups["file"] = [];
	    workGroups["options"] = [];
	    workGroups["help"] = [];
	    workGroups[defaultGroup] = [];

	    defaultGroupLC = defaultGroup.toLowerCase();

	    // Add group names from menu item widgets
	    for (var i = 0; i < m.length; i++) {
		if( m[i].wGroupName && m[i].wGroupName != "" ) { 
		    var name = m[i].wGroupName.toLowerCase();
		    m[i].menuGroup = name;
		    workGroups[name] = [];
		}
		else {
		    m[i].menuGroup = defaultGroupLC;
		}
		
		if( m[i].wLabel && m[i].wLabel != "" ) { 
		    var name = m[i].wLabel.toLowerCase();
		    m[i].menuLabel = name;
		}
		else
		    m[i].menuLabel = null;
	    }

	    groupCount = workGroups.length;

	    //***********************************************************
	    // 2 - Find widgets that define these groups and adjust names
	    //***********************************************************

	    // If found add Command number to list for dups and adjust names to be unique
		    var topLevelMenus = {};

	    for (var i = 0; i < m.length; i++) {
		if( m[i].menuLabel ) {
		    if( workGroups[m[i].menuLabel] ) {
			workGroups[m[i].menuLabel].push( parseInt( m[i].wCommand ));
			m[i].menuLabel = ":" + m[i].wCommand + ":" + m[i].menuLabel;

			if( m[i].wGroupName == null )
			    topLevelMenus[m[i].menuLabel] = true;
		    }
		    //else {
		    //	if( m[i].wGroupName == null ) {
		    //	    m[i].menuGroup = defaultGroupLC;
		    //	}
		    //}
		}
	    }

	    for( var key in workGroups ) {
		var group = workGroups[key];
		if( group.length == 0 )
		    topLevelMenus[key] = true;
	    }

	    //**************************************************************
	    // 3 - Find widgets that belong to these groups and adjust names
	    //**************************************************************
	    // Find menu items that link to these groups and adjust their group names
	    // For dups, a child belongs to the group that it's command is less that or equal to.
	    // It there are none less than or equal then use the first one in the list.
	    for (var i = 0; i < m.length; i++) {
		if( m[i].menuGroup ) {
		    var name = m[i].menuGroup;
		    var group = workGroups[name];
		    if( group ) {
			var found = -1;
			for(var j = 0; j < group.length; j++) { 
			    if( group[j] <= parseInt( m[i].wCommand )) {
				found = j;
			    }
			}
			
			if( found < 0 && group.length > 0 )
			    found = 0;
			
			if( found >= 0 ) {
			    m[i].menuGroup = ":" + group[found] + ":" + m[i].menuGroup;
			}
		    }
		}
	    }

	    var menuGroupNames = [];

	    // Add known menu groups
	    menuGroupNames["file"] = [];
	    menuGroupNames["options"] = [];
	    menuGroupNames["help"] = [];

	    // Add group names from menu item widgets
	    for (var i = 0; i < m.length; i++) {
		if( m[i].menuGroup ) { 
		    menuGroupNames[m[i].menuGroup] = [];
		}
	    }


 	    //**************************************************************
	    // 4 - Create a flat list of menu groups and their children
	    //**************************************************************
	    var menuGroups  = {};
	    var topMenuList = [];

	    //menuGroups["file"] = [];
	    //topMenuList.push("file");

	    for (var i = 0; i < m.length; i++) {
		var lname = m[i].menuLabel;
		var gname = m[i].menuGroup;
		
		if( lname ) {
		    if( gname ) {
			var mgroup = menuGroups[gname];
			
			if( ! mgroup ) {
			    menuGroups[gname] = new mGroup(gname,m[i].wGroupName,null);
			    mgroup = menuGroups[gname];
			    
			    if( topLevelMenus[gname] )
				topMenuList.push(gname);
			}
		    }
		    
		    mgroup.children.push(new mChild(lname,m[i].wLabel,m[i]));

		    var mgn = menuGroupNames[lname];
			
		    if( mgn ) {
			if( menuGroups[lname] ) {
			    menuGroups[lname].widget = m[i];
			}
			else {
			    menuGroups[lname] = new mGroup(lname,m[i].wLabel,m[i]);
			    
			    if( topLevelMenus[lname] )
				topMenuList.push(lname);
			}
		    }
		}
	    }

	    //debugger;

 	    //**************************************************************
	    // 5 - Turn the flat list into an indented structure to return
	    //**************************************************************

	    function menuChild(menuName) {
		var mgroup = menuGroups[menuName];
		var menuNode = new MenuNode(mgroup.label,mgroup.widget);
		
		for( var nodeNdx = 0; nodeNdx < mgroup.children.length; nodeNdx++ ) {
		    var mchild = mgroup.children[nodeNdx];

		    if( menuGroups[mchild.menuLabel] )
			menuNode.children.push(menuChild(mchild.menuLabel));
		    else
			menuNode.children.push(new MenuItem(mchild.label,mchild.widget));
		}
		    
		return menuNode;
	    }

	    //var menuTree = new MenuTree();

	    for( var topNdx = 0; topNdx < topMenuList.length; topNdx++ ) {
		var menuName = topMenuList[topNdx];
		if( menuGroups[menuName].children.length > 0 ) {
		    var menuNode = menuChild(menuName);
		    
		    if( menuName == 'file' )
			menuTree.fileMenu = menuNode;
		    else if( menuName == 'options' )
			menuTree.optnMenu = menuNode;
		    else if( menuName == 'help' )
			menuTree.helpMenu = menuNode;
		    else
			menuTree.userMenu.push(menuNode);
		}
	    }
	    //debugger;

	    //return menuTree;
	}
        
function getMenuGroups(m) {
	//debugger;
    for (var i = 0; i < m.length; i++) {
        if (m[i].wGroupName) {
            if (m[i].wGroupName != "" && menugroups.indexOf(m[i].wGroupName) < 0) {
                menugroups.push(m[i].wGroupName);
                menu[m[i].wGroupName] = {};
                menu[m[i].wGroupName].groups = [];
                menu[m[i].wGroupName].items = [];
                menu[m[i].wGroupName].level = 1;
                menu[m[i].wGroupName].isGroup = true;
                menu[m[i].wGroupName].parent = m[i].wGroupName;
            }
        } else {
            //top level
            menu[m[i].wLabel] = {};
            menu[m[i].wLabel].groups = [];
            menu[m[i].wLabel].level = 0;
        }
    }

    //debugger;
    //process menu headerdata
    var mheaderitem = appx_session.currentmenu.header;
    for (var mh = 0; mh < mheaderitem.length; mh++) {
        if (menugroups.indexOf(mheaderitem[mh].wLabel) < 0) {
            menugroups.push(mheaderitem[mh].wLabel);
            menu[mheaderitem[mh].wLabel] = {};
            menu[mheaderitem[mh].wLabel].groups = [];
            menu[mheaderitem[mh].wLabel].items = [];
            menu[mheaderitem[mh].wLabel].level = 1;
            menu[mheaderitem[mh].wLabel].isGroup = true;
            menu[mheaderitem[mh].wLabel].parent = mheaderitem[mh].wLabel;
        }
    }

    menu.groups = menugroups;
    //setGroupHier(menugroups, m);

}

function getMenuLabels(m) {
        
    for (var i = 0; i < m.length; i++) {
        if (m[i].wLabel) {
            if (m[i].wLabel != "") {
                menulabels.push(m[i].wLabel);


                if (menugroups.indexOf(m[i].wLabel) > -1) {
                    menu[m[i].wLabel].isGroup = true;
                    if (m[i].wGroupName && m[i].wGroupName != "") {
                        //debugger;
                        menu[m[i].wLabel].parent = m[i].wGroupName;
                    } else {
                        menu[m[i].wLabel].parent = m[i].wLabel;
                    }
                    menu[m[i].wLabel].command = m[i].wCommand;
                }

                if (m[i].wGroupName && m[i].wGroupName != "" && menugroups.indexOf(m[i].wGroupName) > -1) {
                    menu[m[i].wGroupName].items.push(m[i]);
                }

                if ((m[i].wGroupName == null || m[i].wGroupName == "") && menugroups.indexOf(m[i].wLabel) < 0) {
                    //for (var mh = 0; mh < appx_session.currentmenu.header.length; mh++) {
                    //debugger;
                    menu[new Widget(null, null, appx_session.currentmenu.block.data.headerdata).wLabel].items.push(m[i]);
                    //}
                }
                    

            }
        }
    }

    //setGroupHier(menugroups, m);

}

function setGroupHier(g, m) {
    for (var i = 0; i < m.length; i++) {
        if (m[i].wGroupName) {
            if (m[i].wGroupName != "" && menugroups.indexOf(m[i].wGroupName) < 0) {
                menugroups.push(m[i].wGroupName);
            }
        } else {

        }
    }
}

function buildMenuHTMLtree(menuNode) {

    //debugger;

	if( menuNode == null || menuNode.children.length == 0 )
	    return "";
	var cmd = (menuNode.widget == null ? '' : " onclick='appxwidgetcallback(" + menuNode.widget.wCommand + ")'");
	var wHTML = "<li" + cmd + ">" + (menuNode.widget == null ? menuNode.label : menuNode.widget.wLabel) + "<ul>";

	for( var ndx=0; ndx<menuNode.children.length; ndx++ ) {
	    var menuObj = menuNode.children[ndx];
	    if (menuObj instanceof MenuNode) {
	        wHTML += buildMenuHTMLtree(menuObj);
	    } else {
	        //FIXME - Convert to jQuery objects and use .click()
//                var class = "";
//                if(menuObj.widget) {
//                    //
	        //                }
	        var wgt = (menuObj.widget == null ? false : true);
	        var cmd = null;
	        var lbl = null;
            //TODO: Fix ME add a class for enabled menu items(.appx-menu-item), not an inline style
	        var style = " style='background-position:2% center;background-repeat:no-repeat;background-size:14px 14px;padding-left: 25px;'";
            var sepbefore = false;
            var sepafter = false;
            var disabled = '';
            if (wgt) {
	            cmd = " onclick='appxwidgetcallback(" + menuObj.widget.wCommand + ")'";
	            if (cmd && menuObj.widget.wCommand == "20032") {
	                cmd = " onclick='appx_session.showPreferences()' ";
	            }
	            lbl = menuObj.widget.wLabel;
	            sepbefore = menuObj.widget.wSepBefore == null ? false : true;
	            sepafter = menuObj.widget.wSepAfter == null ? false : true;
	            //debugger;
	            //if (menuObj.widget.wEnabled == false) {
		    //debugger;
		    //}
	            disabled = menuObj.widget.wEnabled == false ? ' disabled' : '';
	            //TODO: Fix ME add a class for disabled menu items(.appx-menu-item .appx-menu-item-disabled), not an inline style
	            style = menuObj.widget.wEnabled == false ? " style = 'background-position:2% center;background-repeat:no-repeat;background-size:14px 14px;padding-left: 25px;color: #eee;text-shadow: 1px 1px #333'" : style;
	            cmd = menuObj.widget.wEnabled == false ? "" : cmd;
	        } else {
                lbl =  menuObj.label;
            }
	        var li = $("<li" + cmd + "" + style + "" + disabled + ">");
	        $(li).text(lbl);
	        if (sepbefore) $(li).addClass("sepbefore");
	        if (sepafter) $(li).addClass("sepafter");
	        if (disabled) $(li).prop("disabled", true);
	        var icon = (wgt == false ? false : menuObj.widget.wIconEnabled == null ? false : $(li).addClass(appxGetCacheIcon(menuObj.widget.wIconEnabled)));
	        //$(lI).css("background-position", "left center");
	        wHTML += $(li)[0].outerHTML;
	        //wHTML += "<li>" + (menuObj.widget == null ? menuObj.label : menuObj.widget.wLabel) + " cc2 </li>";
	    }
	}

	wHTML += "</ul></li>";

	return wHTML;
}

function buildMenuHTML(menuTree) {

    //debugger;
    //var mendiv = $("<div style='width:100%; height: auto; display: block; clear:both;'>").appendTo("body");
    $("#appx-main-nav").html("");

    //var menunav = $("#appx-main-nav").css({ "width": $("#appx_main_container").width(), "top": "0px", "left": ($(document).width() - $("#appx_main_container").width()) / 2 });
    var menunav = $("#appx-main-nav");//.css({ "width": "100%", "top": "0px"});//, "left": ($(document).width() - $("#appx_main_container").width()) / 2 });

    //var topMenu = $("<ul>").attr("id", "topMenu").appendTo(menunav);
    //var topMenu = $("<ul>").attr("id", "topMenu").css({ "width": $("#appx_main_container").width(), "top": "0px", "left": ($(document).width() - $("#appx_main_container").width()) / 2 }).appendTo(menunav);
    var topMenu = $("<ul>").attr("id", "topMenu").css({ "width": $("#appx_main_container").width() }).appendTo(menunav);

    //var popupMenu = $("<div>").attr("id", "popupMenu");

    var menuHTML = "";

    menuHTML += buildMenuHTMLtree(menuTree.fileMenu);
    menuHTML += buildMenuHTMLtree(menuTree.optnMenu);

    for (var ndx = 0; ndx < menuTree.userMenu.length; ndx++)
        menuHTML += buildMenuHTMLtree(menuTree.userMenu[ndx]);

    menuHTML += buildMenuHTMLtree(menuTree.helpMenu);

    $(topMenu).append(menuHTML);

}

function buildPopupMenuHTML(menuTree) {

    //debugger;
    //var mendiv = $("<div style='width:100%; height: auto; display: block; clear:both;'>").appendTo("body");
    $("#appx_popup_nav").html("");

    var menunav = $("#appx_popup_nav");//.css({ "font-size": "13px", "font-family": "arial", "height": "26px", "background": "#eee", "color": "#333", "width": $("#appx_main_container").width(), "top": "0px", "left": ($(document).width() - $("#appx_main_container").width()) / 2, "border-left": "0px solid #D4D0C8", "border-right": "0px solid #D4D0C8" });

    var popupMenu = $("<ul>").attr("id", "popupMenu").appendTo(menunav);

    //var popupMenu = $("<div>").attr("id", "popupMenu");

    var menuHTML = "";

    menuHTML += buildMenuHTMLtree(menuTree.fileMenu);
    menuHTML += buildMenuHTMLtree(menuTree.optnMenu);

    for (var ndx = 0; ndx < menuTree.userMenu.length; ndx++)
        menuHTML += buildMenuHTMLtree(menuTree.userMenu[ndx]);

    menuHTML += buildMenuHTMLtree(menuTree.helpMenu);

    $(popupMenu).append("<li><ul><li>" + menuHTML + "</li></ul></li>");

}


//    function initMenu(m) {
//        
//    }




function createDropDownMenu() {

    //debugger;

    menugroups = [];
    menulabels = [];
    menuitems = [];
    menu = {};
    menu2 = {};
    //$(topMenu2).html("");
    var menuhtml = "";
    var menus = [null, null, null];
    var names = ["Proc", "Appl", "Sys"];

    var menuTree = new MenuTree();
    for (var menuType = 2; menuType >= 0; menuType--) {
        var a = appx_session.currentmenuitems.dropdown[menuType];
        if (a.length > 0) {
            menus[menuType] = fixMenuLabelsAndGroups(a, names[menuType], menuTree);
            //fixMenuLabelsAndGroups(a,names[menuType],menuTree);
        }
    }
    //$("#testhtml").html(menuhtml);
    //alert("count="+groupCount);
    buildMenuHTML(menuTree);
    //getMenuGroups(a);
    //getMenuLabels(a);
    //buildMenuList(a);
    //buildMenuHTML(menu);


}

function createPopupMenu() {

    //debugger;

    menugroups = [];
    menulabels = [];
    menuitems = [];
    menu = {};
    menu2 = {};
    //$(topMenu2).html("");
    var menuhtml = "";
    var menus = [null, null, null];
    var names = ["Proc", "Appl", "Sys"];

    var menuTree = new MenuTree();
    for (var menuType = 2; menuType >= 0; menuType--) {
        var a = appx_session.currentmenuitems.popup[menuType];
        if (a.length > 0) {
            menus[menuType] = fixMenuLabelsAndGroups(a, names[menuType], menuTree);
            //fixMenuLabelsAndGroups(a,names[menuType],menuTree);
        }
    }
    //$("#testhtml").html(menuhtml);
    //alert("count="+groupCount);
    buildPopupMenuHTML(menuTree);
    //getMenuGroups(a);
    //getMenuLabels(a);
    //buildMenuList(a);
    //buildMenuHTML(menu);

}

function createdToolbarMenu() {

    var tbi = [];
//no need to fix toolbar item hierarchy
    for (var menuType = 2; menuType >= 0; menuType--) {
        var a = appx_session.currentmenuitems.toolbar[menuType];
        for (var i = 0; i < appx_session.currentmenuitems.toolbar[menuType].length; i++) {
            tbi.push(appx_session.currentmenuitems.toolbar[menuType][i]);
        }
    }

    var $newtoolbar = $("<div>");
    var $newdeftoolbar = $("<div>");

    while (tbi.length > 0) {
        var mx = {};

        mx.widget = tbi.shift();

        if (mx.widget.wIconEnabled) {
            var item = $('<div style="cursor:pointer; text-align:center; vertical-align: bottom; float:left;height:40px;width:50px;color:black;border: 0px solid #333;background-position:50% 20%;; background-size:50%;">');
            if (mx.widget.wShortLabel) {
                $(item).html('<span style="vertical-align: -25px;font-size:11px;font-family:arial">' + mx.widget.wShortLabel.trim() + '</span>');
                //$(item).html(mx.widget.wShortLabel.trim());
            }
            var arr = mx.widget.wIconEnabled.split('.'), cache = appx_session.image_cache;
            var cacheid = cleanClassName( appx_session.server + "_" + appx_session.port + "_" + arr[0].replace("#","") + "_" + arr[1] + "_" + arr[2] );
            //                    if (!appx_session.image_cache[cacheid]) {
            //                        appx_session.image_cache.length++;
            //                        appx_session.image_cache.keys.push(cacheid);
            //                        appx_session.image_cache[cacheid] = { "cacheid": cacheid, "url": "", "blob": null };
            //                        //if (i == 1) appx_session.image_rollover.push(cacheid);//chrisa rollover
            //                        if (!localStorage.getItem(cacheid)) {
            //                            sendappxresource(mx.widget.wIconEnabled);
            //                        } else {
            //                            appx_session.image_cache[cacheid].blob = new Blob([toArrayBuffer(JSON.parse(localStorage.getItem(cacheid)))]);
            //                            appx_session.image_cache[cacheid].url = window.URL.createObjectURL(appx_session.image_cache[cacheid].blob);
            //                        }
            //                    }

            if (!cache[cacheid]) {
                cache.length++;
                cache.keys.push(cacheid);
                cache[cacheid] = { "cacheid": cacheid, "url": "", "blob": null, "wIcon": mx.widget.wIconEnabled };
                //if (i == 1) appx_session.image_rollover.push(cacheid);//chrisa rollover
                if (!localStorage.getItem(cacheid)) {
                    sendappxresource(mx.widget.wIconEnabled);
                } else {
                    //var curresource = !localStorage.getItem(cacheid);
                    cache[cacheid].blob = new Blob([toArrayBuffer(JSON.parse(localStorage.getItem(cacheid)))]);
                    cache[cacheid].url = window.URL.createObjectURL(cache[cacheid].blob);
                    cache[cacheid].wIcon = mx.widget.wIconEnabled;
                }
            } else {
                if (cache[cacheid].wIcon != mx.widget.wIconEnabled) {
                    cache[cacheid].wIcon = mx.widget.wIconEnabled;
                    sendappxresource(cache[cacheid].wIcon);
                }
            }
            $(item).addClass("appxitem"); //item
            $(item).addClass("toolbaritem");
            $(item).addClass(cacheid);

            var tbenabled = mx.widget.wEnabled == null ? true : mx.widget.wEnabled;

            if (tbenabled == false) {
                $(item).addClass("tbdisabled");
            }

            $(item).attr("id", mx.widget.wCommand);


            $(item).click(function () {
                //var mydata = widgetparams;
                //appxwidgetcallback(1, null);
                //debugger;
                //sendappxshow(this.id, []);
                //send appx show doesn't check dirty flag
                appxwidgetcallback(this.id);
            });


            if (mx.widget.wTooltip) {
                $(item).prop('title', mx.widget.wTooltip);
		$(item).tooltip({content:function(){return this.title();}});
            }
	    else if (mx.widget.wLabel) {
                $(item).prop('title', mx.widget.wLabel);
		$(item).tooltip({content:function(){return this.title();}});
	    }

            //mx.widget.wVisible == null or true if visible, false if not
            var tbvisible = mx.widget.wVisible == null ? true : mx.widget.wVisible;

            if (tbvisible) {
                //$("#toolbar").append(item);
                if (mx.widget.wCommand > "250") { //in ["304", "278"]

                    //FIX ME: deep clone keeps event, don't have to add em back with .clone(true)
                    //TODO: Fix clone
                    var ic = $(item).clone();
                    $(ic).attr("id", "sk_" + mx.widget.wCommand);
                    $(ic).css({ "background-color": "transparent" });
                    $(ic).click(function () {
                        //var mydata = widgetparams;
                        //appxwidgetcallback(1, null);
                        //debugger;
                        var i = this.id.replace("sk_", "");
                        //sendappxshow(i, []);
                        //sendappxshow doesn't check dirty
                        appxwidgetcallback(i);
                    });
                    //$("#appx-defaulttools-container").append(ic);
                    $newdeftoolbar.append(ic);
                } else {
                    //$("#toolbar").append(item);
                    $newtoolbar.append(item);
                }
            }
        }
    }
    $("#default-toolbar").html($newdeftoolbar);
    $("#toolbar").html($newtoolbar);
}

/*

Java Client Code:

public void updateTokenizedMenus() 
{
	if( Globals.getOptionValueBoolean("presentationMode") == true )
		return;
		
	// Clean up previous pulldown menu items.
	for ( int i = 0; i < menuStore.size(); i++ )
	{
		JMenu tmpMenu = (JMenu) menuStore.elementAt(i);
		if( tmpMenu != null )
		{
			for( int cnt=tmpMenu.getMenuComponentCount()-1; cnt>=0; cnt--)
			{
				Component cmp = tmpMenu.getMenuComponent(cnt);
				if( cmp != null )
					tmpMenu.remove(cnt);
			}
	    	mb.remove(tmpMenu);
	    }
	}
	
	menuStore.removeAllElements();

	popupStore.removeAllElements();
	
	// Clean up previous toolbar items.
	for ( int i = 0; i < toolStore.size(); i++ )
	{
		JToolBar tmpBar = (JToolBar) toolStore.elementAt(i);
		
		if( tmpBar.getUI() instanceof BasicToolBarUI && ((BasicToolBarUI)(tmpBar.getUI())). isFloating() )
			((BasicToolBarUI)(tmpBar.getUI())).setFloating(false,null);

		toolBar.remove(tmpBar);
	}
	
	toolStore.removeAllElements();
	
	JToolBar tmpBar = createToolbar("");
		
	// get a list of menus from the document
	Enumeration<TMenu> menus = document.getMenus();

	boolean addPopupSep    = false;

	Hashtable<TMenu, JMenuItem>  menuNodes      = new Hashtable<TMenu, JMenuItem>();
	Hashtable<TMenu, JComponent> popupMenuNodes = new Hashtable<TMenu, JComponent>();
	
	Vector<JMenu> popList = new Vector<JMenu>();
	
	JMenu fileMenu   = null;
	JMenu optionMenu = null;
	JMenu helpMenu   = null;

	// loop through the menus and add them to the menubar
	while ( menus != null && menus.hasMoreElements() )
	{
		TMenu menu = menus.nextElement();

		JMenu tmpMenu      = (JMenu)menuNodes.get(menu);

		if( tmpMenu == null )
		{
			tmpMenu = createMenu(menu.getLabel(),menu.getShortcut());
   		    menuNodes.put(menu, tmpMenu);
   		}
		
		if( menu.tmenuMnu != null && menu.tmenuMnu.widgetData != null )
		{
		    menu.tmenuMnu.widgetData.updateComponent(this, tmpMenu);
		}

		
		JMenu tmpPopupMenu      = (JMenu)popupMenuNodes.get(menu);

		if( tmpPopupMenu == null )
		{
			tmpPopupMenu = createMenu(menu.getLabel(),menu.getShortcut());
   		    popupMenuNodes.put(menu, tmpPopupMenu);
   		}
		
		if( menu.tmenuMnu != null && menu.tmenuMnu.widgetData != null )
		    menu.tmenuMnu.widgetData.updateComponent(this, tmpPopupMenu);
		
		

		// get a list of menuItems from the document
		Enumeration<MMnu> menuItems = menu.getMenuItems();
		
		// loop through the menuItems and add them to the menu
		while( menuItems != null && menuItems.hasMoreElements() )
		{
			MMnu mnu = menuItems.nextElement();	

			if( mnu.widgetData != null && ( mnu.widgetData.wVisible == null || mnu.widgetData.wVisible.booleanValue() == true ))
			{
	            if( mnu.widgetData.wLabel != null )
		        {
					// Pulldown Menu Definitions

			        if( mnu.widgetData.wUsageMenu != null && mnu.widgetData.wUsageMenu.booleanValue() == true)
				    {
					    if( mnu.widgetData.wSepBefore != null && mnu.widgetData.wSepBefore.booleanValue() == true )
						    tmpMenu.add(new JSeparator());

						JMenuItem jmi = null;

						if( mnu.definesTMenu == null )
						{
							if( mnu.widgetData.wCommand != null && (mnu.widgetData.wCommand.equals(""+Document.OPT_GUI_INTERFACE) ||
									                                mnu.widgetData.wCommand.equals(""+Document.OPT_SHOW_OPT_NUMS) ||
									                                mnu.widgetData.wCommand.equals(""+Document.OPT_AUTO_TAB_OUT)  ||
									                                mnu.widgetData.wCommand.equals(""+Document.OPT_AUTO_SELECT)   ||
									                                mnu.widgetData.wCommand.equals(""+Document.OPT_DOCKING_SCROLLB) ||
									                                mnu.widgetData.wCommand.equals(""+Document.OPT_SHOW_GRIDLINES) ))
								jmi = createCheckBoxMenuItem((String)null, ' ',this,null,(String)null);
							else
								jmi = createMenuItem((String)null, ' ',this,null,(String)null);
	
							mnu.widgetData.updateComponent(this, jmi);

							if( jmi.getActionCommand().startsWith("2010"))
							{
								if( jmi.getActionCommand().equals( ""+Document.OPT_GUI_INTERFACE ))
									jmi.setSelected(Globals.getOptionValueBoolean( "guiInterface" ));
								else if( jmi.getActionCommand().equals( ""+Document.OPT_SHOW_OPT_NUMS ))
									jmi.setSelected(Globals.getOptionValueBoolean( "showOptionNumbers" ));
								else if( jmi.getActionCommand().equals( ""+Document.OPT_AUTO_TAB_OUT ))
									jmi.setSelected(Globals.getOptionValueBoolean( "autoTabOut" ));
								else if( jmi.getActionCommand().equals( ""+Document.OPT_AUTO_SELECT ))
									jmi.setSelected(Globals.getOptionValueBoolean( "autoSelect" ));
								else if( jmi.getActionCommand().equals( ""+Document.OPT_DOCKING_SCROLLB ))
									jmi.setSelected(Globals.getOptionValueBoolean( "dockingScrollbar" ));
								else if( jmi.getActionCommand().equals( ""+Document.OPT_SHOW_GRIDLINES ))
									jmi.setSelected(Globals.getOptionValueBoolean( "showGridlines" ));
							}
							
							if( menu.getMenuCommand()           != null && 
						        mnu.definesTMenu                == null && 
						        menu.getMenuCommand().charAt(0) != '0' )
						    {
							    jmi.setActionCommand(menu.getMenuCommand()+","+jmi.getActionCommand());
						    }
						    
						    if( mnu.disable == true )
						        jmi.setEnabled(false);
	   					}
						else
						{
							jmi = (JMenu)menuNodes.get(mnu.definesTMenu);

							if( jmi == null )
							{
							    jmi = createMenu(mnu.definesTMenu.getLabel(),mnu.definesTMenu.getShortcut());
							    menuNodes.put(mnu.definesTMenu, jmi);
							}
		                }

		                tmpMenu.add(jmi);
			            
				        if( mnu.widgetData.wSepAfter != null && mnu.widgetData.wSepAfter.booleanValue() == true )
					        tmpMenu.add(new JSeparator());
	                }
				
					// Popup Menu Definitions
		            if( mnu.widgetData.wUsagePopup != null && mnu.widgetData.wUsagePopup.booleanValue() == true )
			        {
					    if( mnu.widgetData.wSepBefore != null && mnu.widgetData.wSepBefore.booleanValue() == true )
						    tmpPopupMenu.add(new JSeparator());

						JComponent jmi = null;
						
						if( mnu.definesTMenu == null )
						{
	   					    jmi = createMenuItem((String)null, ' ',this,null,(String)null);
	
							mnu.widgetData.updateComponent(this, jmi);
						
						    if( menu.getMenuCommand()          != null && 
						        mnu.definesTMenu               == null && 
						        menu.getMenuCommand().charAt(0) != '0' )
							    ((AppxJMenuItem)jmi).setActionCommand(menu.getMenuCommand()+","+((AppxJMenuItem)jmi).getActionCommand());
							
						    if( mnu.disable == true )
						        jmi.setEnabled(false);
	   					}
						else
						{
							jmi = (JMenu)popupMenuNodes.get(mnu.definesTMenu);
						
							if( jmi == null )
							{
							    jmi = createMenu(mnu.definesTMenu.getLabel(),mnu.definesTMenu.getShortcut());
							    popupMenuNodes.put(mnu.definesTMenu, jmi);
							}
		                }
		                
		                tmpPopupMenu.add(jmi);

				        if( mnu.widgetData.wSepAfter != null && mnu.widgetData.wSepAfter.booleanValue() == true )
					        tmpPopupMenu.add(new JSeparator());
	                }

					// Toolbar Definitions
					if( mnu.widgetData.wUsageToolbar != null && mnu.widgetData.wUsageToolbar.booleanValue() == true && mnu.definesTMenu == null )
			        {
				        if( mnu.widgetData.wSepBefore != null && mnu.widgetData.wSepBefore.booleanValue() == true )
					        tmpBar.add(new CharView.Separator(true));

				        AppxToolbarButton jmi = addToToolBar((String)null,(String)null,(String)null);

	                    if( jmi != null )
	                    {
							mnu.widgetData.updateToolbarComponent(this, jmi);

							if( mnu.widgetData.wTooltip == null )
								jmi.setToolTipText(mnu.widgetData.wLabel);

							if( mnu.disable == true )
	    					    jmi.setEnabled(false);

							if( mnu.widgetData.wIconEnabled != null )
							{							
								if( menu.getMenuCommand()           != null &&
								    menu.getMenuCommand().charAt(0) != '0' )
									jmi.setActionCommand(menu.getMenuCommand()+","+jmi.getActionCommand());

		    	            	tmpBar.add(jmi);
		    	            }
			    		}
			    		        
				        if( mnu.widgetData.wSepAfter != null && mnu.widgetData.wSepAfter.booleanValue() == true )
					        tmpBar.add(new CharView.Separator(true));
					}

				} // mnu.widgetData.wLabel != null
			} // menu.widgetData != null
		} // while(menuitems...

		if( tmpMenu != null && tmpMenu.getSubElements().length > 0 && (menu.tmenuMnu == null || menu.tmenuMnu.parent == null) )
		{
			if( mb.getComponentCount() > 1 && Globals.getOptionValueBoolean( "hideStaticClientMenus" ) == false && checkForFeature(IOHandler.FEATURE_SERVER_PULLDOWNS) == false )
				mb.add(tmpMenu,mb.getComponentCount()-2);
			else if( tmpMenu.getText().equalsIgnoreCase("file") )
				fileMenu = tmpMenu;
			else if( tmpMenu.getText().equalsIgnoreCase("options") )
				optionMenu = tmpMenu;
			else if( tmpMenu.getText().equalsIgnoreCase("help") )
				helpMenu = tmpMenu;
			else
			{
				mb.add(tmpMenu,mb.getComponentCount());
			}
			
			
	    	menuStore.addElement(tmpMenu);
		}

		if( menu.tmenuMnu == null || menu.tmenuMnu.parent == null )
		    popList.addElement(tmpPopupMenu);
	}

	if( fileMenu != null )
	{
		mb.add(fileMenu,0);
		fileMenu = null;
	}
	
	if( optionMenu != null )
	{
		mb.add(optionMenu,mb.getComponentCount());
		optionMenu = null;
	}
		
	if( helpMenu != null )
	{
		mb.add(helpMenu,mb.getComponentCount());
		helpMenu = null;
	}
		

	    if( tmpBar.getComponentCount() > 0 )
	    {
	    	tmpBar.add(new CharView.Separator(false));
	        toolBar.add(tmpBar);
			toolStore.addElement(tmpBar);
		}
		

	addPopupSep = false;
	
	for( JMenu popC : popList )
	{
		int compCnt = popC.getItemCount();
		
		if( compCnt > 0 )
		{
			if( addPopupSep )
				popupStore.addElement(new JSeparator());
				
			for( int compIdx=0; compIdx < compCnt; compIdx++ )
			{
				popupStore.addElement(popC.getMenuComponent(compIdx));
			}
			
			addPopupSep = true;
		}
	}
}


*/
