﻿/****************************************************************************/
//Resource Functions : appx-client-token.js
//01/28/2014
//Chris Smith
/****************************************************************************/


//RESOURCE Message Handler
function appxtokenhandler(x) {
    //alert("got a resource...");
    //inject_image2(x.data.data);
    create_tokens(x);
}

function sendappxtoken(grp) {

    var ms = {
        cmd: 'appxtoken',
        args: grp,
        handler: 'appxtokenhandler',
        data: null
    };

    appx_session.ws.send(JSON.stringify(ms));
}

function create_tokens(x) {
    //console.log(x);

    var cacheid = appx_session.token_groups[x.data.grp.slice(2,4)];
    
    if (!localStorage.getItem(cacheid)) {
        localStorage.setItem(cacheid, JSON.stringify(x));
    }

    appx_session.token_cache[cacheid].data = JSON.parse(localStorage.getItem(cacheid));

    applytokens();

}

function applytokens() {
try {
    //console.log("applying tokens");
    if (appx_session.token_cache) {
        for (var i = 0; i < appx_session.token_cache.keys.length; i++) {
            var key = appx_session.token_cache.keys[i];
            if (key != "") {
		if( ! localStorage.getItem(key) ) {
		    console.log("key not in cache");
		    continue;
		}
                //$("." + key).css({ "background": "lime" });
                var itemvals = JSON.parse(localStorage.getItem(key)).data.items;

                $("." + key).each(function (index, item) {
                    if ($(this).prop("tagName") == "SELECT") {
                        var sel = $(this);
                        $(this).html("");
                        if ($(this).hasClass("appx-nullok"))
                            $(this).append("<option></option>");
                        $.each(itemvals, function (i, val) {
                            var ov = ab2str(val.data).trim();
                            var frag = $('<option></option>').val(ov).html(ov);
                            sel.append(frag);
                        });
                    }
                    $(this).val($(this).attr("data"));
                });

                //setappxcombo(key);
            }
        }
    }
} catch(ex) { console.log("applytokens: " + ex); }
}

function setappxcombo(key) {


    $("." + key).autocomplete({
        source: ["c", "java", "php", "coldfusion", "javascript", "asp", "ruby"]
    });

    //$.widget("." + key, );
    /*
    $("." + key).autocomplete(

    {
        _create: function () {
            this.wrapper = $("<span>")
          .addClass("custom-combobox")
          .insertAfter(this.element);

            this.element.hide();
            this._createAutocomplete();
            this._createShowAllButton();
        },

        _createAutocomplete: function () {
            var selected = this.element.children(":selected"),
          value = selected.val() ? selected.text() : "";

            this.input = $("<input>")
          .appendTo(this.wrapper)
          .val(value)
          .attr("title", "")
          .addClass("custom-combobox-input ui-widget ui-widget-content ui-state-default ui-corner-left")
          .autocomplete({
              delay: 0,
              minLength: 0,
              source: $.proxy(this, "_source")
          })
          .tooltip({
              tooltipClass: "ui-state-highlight"
          });

            this._on(this.input, {
                autocompleteselect: function (event, ui) {
                    ui.item.option.selected = true;
                    this._trigger("select", event, {
                        item: ui.item.option
                    });
                },

                autocompletechange: "_removeIfInvalid"
            });
        },

        _createShowAllButton: function () {
            var input = this.input,
          wasOpen = false;

            $("<a>")
          .attr("tabIndex", -1)
          .attr("title", "Show All Items")
          .tooltip()
          .appendTo(this.wrapper)
          .button({
              icons: {
                  primary: "ui-icon-triangle-1-s"
              },
              text: false
          })
          .removeClass("ui-corner-all")
          .addClass("custom-combobox-toggle ui-corner-right")
          .mousedown(function () {
              wasOpen = input.autocomplete("widget").is(":visible");
          })
          .click(function () {
              input.focus();

              // Close if already visible
              if (wasOpen) {
                  return;
              }

              // Pass empty string as value to search for, displaying all results
              input.autocomplete("search", "");
          });
        },

        _source: function (request, response) {
            var matcher = new RegExp($.ui.autocomplete.escapeRegex(request.term), "i");
            response(this.element.children("option").map(function () {
                var text = $(this).text();
                if (this.value && (!request.term || matcher.test(text)))
                    return {
                        label: text,
                        value: text,
                        option: this
                    };
            }));
        },

        _removeIfInvalid: function (event, ui) {

            // Selected an item, nothing to do
            if (ui.item) {
                return;
            }

            // Search for a match (case-insensitive)
            var value = this.input.val(),
          valueLowerCase = value.toLowerCase(),
          valid = false;
            this.element.children("option").each(function () {
                if ($(this).text().toLowerCase() === valueLowerCase) {
                    this.selected = valid = true;
                    return false;
                }
            });

            // Found a match, nothing to do
            if (valid) {
                return;
            }

            // Remove invalid value
            this.input
          .val("")
          .attr("title", value + " didn't match any item")
          .tooltip("open");
            this.element.val("");
            this._delay(function () {
                this.input.tooltip("close").attr("title", "");
            }, 2500);
            this.input.data("ui-autocomplete").term = "";
        },

        _destroy: function () {
            this.wrapper.remove();
            this.element.show();
        }
    }

    );

    */
}
